﻿--[[                   TITAN PANEL: CAMERA DISTANCE
              
  Описание/Description:
• ru:  Дистанция Камеры - небольшой плагин для Титан Панели. Спомощью него в выпадающем меню можно выбрать максимальную дистанцию обзора камеры: от минимального - 0 метров (вид от первого лица) 
        до максимального - 50 метров
• en:  Camera Distance - a small plug-in for Titan Panel. With him in dropdown menu, you can select the maximum range of camera distance: from minimum - 0 yards (first-person view)
        to maximum - 50 yards

Author: Wishko (EU-Thermoplugg)      Автор: Вишко (EU-Термоштепсель)   
E-mail: Wish1250@gmail.com           Мыло: Wish1250@gmail.com    
Create Date: 9 june 2010             Дата создания: 9 июня 2010  
CurrentVersion: 1.2.3                Текущая версия: 1.2.3
Locales: RU,EN                       Языки: RU,EN

  Изменения/ChangeLog:
• v1.1.2 (9 june 2010)   - Релиз
                           Initial Release
• v1.1.3 (8 jule 2010)   - Небольшие изменения в загрузке плагина; добавлены, изменены и локализованы некоторые подсказки 
                           Minor changes in plugin loading; added, modified and localized some tips
• v1.2.0 (10 jule 2010)  - Изменена структура аддона. Теперь можно выбрать любую дистанцию, а не каждую вторую. Исправлены небольшие ошибки      
                           Changed addon structure. Now you can choose any distance, not every second. Fixed small bugs
• v1.2.1 (14 jule 2010)  - Исправлены небольшие ошибки
                           Fixed small bugs
• v1.2.2 (29 jule 2010)  - Добавлено отображение выбранной дистанции на кнопке плагина. Локализация упорядочена, вынесена в отдельный файл и теперь использует LibStub("AceLocale-3.0")
                           Added display of selected distance on plug-in button. Localization ordered, moved to separate file
• v1.2.3 (1 august 2010) - Изменены некоторые подсказки. Теперь дистанция камеры в Интерфейсе автоматически устанавливается на минимальную после выбора любой дистанции в плагине (ранее требовалось сделать это вручную).
                           Удалена кнопка "Помощь". Добавлена функция "Автоизменение дистанции", при выборе которой камера будет автоматически устанавливаться на максимальное расстояние (ранее требовалось сделать это вручную)
                           Если кто-то читает эти ChangeLog'и, то напишите в игре "/CamDist"
                           Modified some tips. Now camera distance in Interface is automatically installed to minimum after selecting any distance in plugin (previously required to do it manually).
                           Deleted "Help" button. Added function "Autochange distance",when it choosing, camera will automatically set at maximum distance (previously required to do it manually)
                          
]]--

local TITAN_CAMDIST_VERSION = "1.2.3"
local TITAN_CAMDIST_ID = "CamDist"
local updateTable = {TITAN_CAMDIST_ID, TITAN_PANEL_UPDATE_ALL};
local L = LibStub("AceLocale-3.0"):GetLocale("CamDist", true)
------------------------------------------------------------------------
function TitanPanelCamDistButton_OnLoad(self)
	self.registry = {
		id = TITAN_CAMDIST_ID,
		category = "Interface",
        version = TITAN_CAMDIST_VERSION,
		menuText = L["TITAN_CAMDIST_MENUTEXT"],
		buttonTextFunction = "TitanPanelCamDist_GetButtonText",
        tooltipTitle = L["TITAN_CAMDIST_TOOLTIPTITLE"],
        tooltipTextFunction = "TitanPanelCamDist_GetTooltipText",
		icon = "Interface\\Icons\\Spell_Fire_Flare",
		iconWidth = 16,
		savedVariables = {
			ShowIcon = 1,
            CameraAutoZoom = 0,
			}}; 
            
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end
------------------------------------------------------------------------
function TitanPanelCamDistButton_OnEvent(self, event, ...)
if event == "PLAYER_ENTERING_WORLD" then self:SetScript("OnUpdate", TitanPanelCamDistButton_OnUpdate) end
end 
function TitanPanelCamDistButton_OnUpdate(self) 
TitanPanelPluginHandle_OnUpdate(updateTable)
end
------------------------------------------------------------------------
function TitanPanelCamDist_GetButtonText()
local TITAN_CAMDIST_CVAR_DISTMAX = floor(GetCVar("cameraDistanceMax"))
TITAN_CAMDIST_BUTTONTEXT = L["TITAN_CAMDIST_BUTTONTEXT"].."|cff00ff00"..TITAN_CAMDIST_CVAR_DISTMAX..""
return TITAN_CAMDIST_BUTTONTEXT
end
------------------------------------------------------------------------
function TitanPanelCamDist_GetTooltipText() 
return L["TITAN_CAMDIST_TOOLTIPTEXT"]
end
------------------------------------------------------------------------
-- Функция Автоизменения дистанции
local function CamDistAutoZoom()
TitanToggleVar(TITAN_CAMDIST_ID, "CameraAutoZoom");
MoveViewOutStop()
TitanPanelPluginHandle_OnUpdate(updateTable)
end
-- Максимальная дистанция камеры от 0 до 50 и сброс дистанции камеры в Интерфейсе (Ничего лучше придумать не мог чем все это написать))
local function CamDist0() 
SetCVar("cameraDistanceMax",0)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist1()
SetCVar("cameraDistanceMax",1)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist2()
SetCVar("cameraDistanceMax",2)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist3()
SetCVar("cameraDistanceMax",3)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist4()
SetCVar("cameraDistanceMax",4)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist5()
SetCVar("cameraDistanceMax",5)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(0.5) end
end 
local function CamDist6()
SetCVar("cameraDistanceMax",6)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
end
local function CamDist7()
SetCVar("cameraDistanceMax",7)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
end 
local function CamDist8()
SetCVar("cameraDistanceMax",8)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
end 
local function CamDist9()
SetCVar("cameraDistanceMax",9)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
end 
local function CamDist10()
SetCVar("cameraDistanceMax",10)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1) end
end 
local function CamDist11()
SetCVar("cameraDistanceMax",11)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist12()
SetCVar("cameraDistanceMax",12)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist13()
SetCVar("cameraDistanceMax",13)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end
local function CamDist14()
SetCVar("cameraDistanceMax",14)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist15()
SetCVar("cameraDistanceMax",15)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist16()
SetCVar("cameraDistanceMax",16)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist17()
SetCVar("cameraDistanceMax",17)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist18()
SetCVar("cameraDistanceMax",18)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist19()
SetCVar("cameraDistanceMax",19)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist20()
SetCVar("cameraDistanceMax",20)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end
local function CamDist21()
SetCVar("cameraDistanceMax",21)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist22()
SetCVar("cameraDistanceMax",22)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist23()
SetCVar("cameraDistanceMax",23)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist24()
SetCVar("cameraDistanceMax",24)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end
local function CamDist25()
SetCVar("cameraDistanceMax",25)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(1.5) end
end 
local function CamDist26()
SetCVar("cameraDistanceMax",26)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist27()
SetCVar("cameraDistanceMax",27)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist28()
SetCVar("cameraDistanceMax",28)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist29()
SetCVar("cameraDistanceMax",29)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist30()
SetCVar("cameraDistanceMax",30)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist31()
SetCVar("cameraDistanceMax",31)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist32()
SetCVar("cameraDistanceMax",32)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist33()
SetCVar("cameraDistanceMax",33)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist34()
SetCVar("cameraDistanceMax",34)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2) end
end 
local function CamDist35()
SetCVar("cameraDistanceMax",35)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist36()
SetCVar("cameraDistanceMax",36)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist37()
SetCVar("cameraDistanceMax",37)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist38()
SetCVar("cameraDistanceMax",38)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist39()
SetCVar("cameraDistanceMax",39)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist40()
SetCVar("cameraDistanceMax",40)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist41()
SetCVar("cameraDistanceMax",41)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist42()
SetCVar("cameraDistanceMax",42)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist43()
SetCVar("cameraDistanceMax",43)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist44()
SetCVar("cameraDistanceMax",44)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist45()
SetCVar("cameraDistanceMax",45)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(2.5) end
end 
local function CamDist46()
SetCVar("cameraDistanceMax",46)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end
end 
local function CamDist47()
SetCVar("cameraDistanceMax",47)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end
end 
local function CamDist48()
SetCVar("cameraDistanceMax",48)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end
end 
local function CamDist49()
SetCVar("cameraDistanceMax",49)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end
end 
local function CamDist50()
SetCVar("cameraDistanceMax",50)
SetCVar("cameraDistanceMaxFactor",1)
if (TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom")) then  MoveViewOutStart(3) end
end 
 
------------------------------------------------------------------------
function TitanPanelRightClickMenu_PrepareCamDistMenu()
local info;
------------------------------------------------------------------------
-- 2й УРОВЕНЬ
------------------------------------------------------------------------
        -- Меню 2го уровня, Дистанции 1-9    
        if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then
		if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist0" ) then
        info = {};
		info.text = ("|cff00ff001|r"..L["TITAN_CAMDIST_ONE_METER"].."")
        info.func = function() CamDist1() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff002|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist2() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff003|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist3() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff004|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist4() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff005|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist5() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff006|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist6() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff007|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist7() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff008|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist8() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff009|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist9() end;
		UIDropDownMenu_AddButton(info,2) 
        end

    -- Меню 2го уровня, Дистанции 11-19   
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist10" ) then
		info = {};
		info.text = ("|cff00ff0011|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist11() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0012|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist12() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff0013|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist13() end;
		UIDropDownMenu_AddButton(info,2) 
                                
        info = {};
		info.text = ("|cff00ff0014|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist14() end;
		UIDropDownMenu_AddButton(info,2) 
             
        info = {};
		info.text = ("|cff00ff0015|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist15() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0016|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist16() end;
		UIDropDownMenu_AddButton(info,2) 
                               
        info = {};
		info.text = ("|cff00ff0017|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist17() end;
		UIDropDownMenu_AddButton(info,2)
                        
        info = {};
		info.text = ("|cff00ff0018|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist18() end;
		UIDropDownMenu_AddButton(info,2) 
                             
        info = {};
		info.text = ("|cff00ff0019|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist19() end;
		UIDropDownMenu_AddButton(info,2) 
             
             
        end
   
    -- Меню 2го уровня, Дистанции 21-29          
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist20" ) then
		info = {};
		info.text = ("|cff00ff0021|r"..L["TITAN_CAMDIST_ONE_METER"].."")
        info.func = function() CamDist21() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0022|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist22() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff0023|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist23() end;
		UIDropDownMenu_AddButton(info,2) 
                
        info = {};
		info.text = ("|cff00ff0024|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist24() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0025|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist25() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0026|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist26() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0027|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist27() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0028|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist28() end;
		UIDropDownMenu_AddButton(info,2) 
                        
        info = {};
		info.text = ("|cff00ff0029|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist29() end;
		UIDropDownMenu_AddButton(info,2) 
        
        end
        
    -- Меню 2го уровня, Дистанции 31-39         
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist30" ) then
        info = {};
		info.text = ("|cff00ff0031|r"..L["TITAN_CAMDIST_ONE_METER"].."")
        info.func = function() CamDist31() end;
		UIDropDownMenu_AddButton(info,2) 
        
		info = {};
		info.text = ("|cff00ff0032|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist32() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0033|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist33() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0034|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist34() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0035|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist35() end;
		UIDropDownMenu_AddButton(info,2) 
                  
        info = {};
		info.text = ("|cff00ff0036|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist36() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0037|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist37() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0038|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist38() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0039|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist39() end;
		UIDropDownMenu_AddButton(info,2) 
        end
        
    -- Меню 2го уровня, Дистанции 41-49         
        if ( UIDROPDOWNMENU_MENU_VALUE == "CamDist40" ) then
        info = {};
		info.text = ("|cff00ff0041|r"..L["TITAN_CAMDIST_ONE_METER"].."")
        info.func = function() CamDist41() end;
		UIDropDownMenu_AddButton(info,2) 
        
		info = {};
		info.text = ("|cff00ff0042|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist42() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0043|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist43() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0044|r"..L["TITAN_CAMDIST_TWO_METER"].."")
        info.func = function() CamDist44() end;
		UIDropDownMenu_AddButton(info,2) 
           
        info = {};
		info.text = ("|cff00ff0045|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist45() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0046|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist46() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0047|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist47() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0048|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist48() end;
		UIDropDownMenu_AddButton(info,2) 
        
        info = {};
		info.text = ("|cff00ff0049|r"..L["TITAN_CAMDIST_METERS"].."")
        info.func = function() CamDist49() end;
		UIDropDownMenu_AddButton(info,2) 
        end 
        else
        
------------------------------------------------------------------------
-- 1й УРОВЕНЬ
------------------------------------------------------------------------
-- Меню 1го уровня. Дистанции 0,10,20,30,40,50.   
   	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_CAMDIST_ID].menuText)
   	info = {};
   	info.text = ("   |cff00ff000|r"..L["TITAN_CAMDIST_METERS"].."")
    info.value = "CamDist0"
    info.func = function() CamDist0() end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    
    info = {};
   	info.text = ("|cff00ff0010|r"..L["TITAN_CAMDIST_METERS"].."")
    info.value = "CamDist10"
    info.func = function() CamDist10() end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);
    
   	info = {};
   	info.text = ("|cff00ff0020|r"..L["TITAN_CAMDIST_METERS"].."")
    info.value = "CamDist20"
    info.func = function() CamDist20() end;
    info.hasArrow = 1;
    UIDropDownMenu_AddButton(info);

   	info = {};
   	info.text = ("|cff00ff0030|r"..L["TITAN_CAMDIST_METERS"].."")
    info.hasArrow = 1;
    info.value = "CamDist30"
    info.func = function() CamDist30() end;
    UIDropDownMenu_AddButton(info);

   	info = {};
   	info.text = ("|cff00ff0040|r"..L["TITAN_CAMDIST_METERS"].."")
    info.value = "CamDist40"
    info.func = function() CamDist40() end;
    info.hasArrow = 1
    UIDropDownMenu_AddButton(info);
    
    info = {};
   	info.text = ("|cff00ff0050|r"..L["TITAN_CAMDIST_METERS"].."")
    info.value = "CamDist50"
    info.func = function() CamDist50() end;
    UIDropDownMenu_AddButton(info);
    
    TitanPanelRightClickMenu_AddSpacer()
    
    info = {};
	info.text = L["TITAN_CAMDIST_AUTOZOOM"];
    info.func = function() CamDistAutoZoom() end;
    info.checked = TitanGetVar(TITAN_CAMDIST_ID, "CameraAutoZoom");
    UIDropDownMenu_AddButton(info)
    
	TitanPanelRightClickMenu_AddToggleIcon(TITAN_CAMDIST_ID)  
end
end

-- Ну надо же было добавить сюда чего-нибудь интересного, вот и придумал это)):
-- Правда тут вышла парочка накладок, и не все получилось так, как задумано
SLASH_TITANCAMDIST1 = "/CamDist"
SlashCmdList["TITANCAMDIST"] = TITANCAMDIST_Command
function TITANCAMDIST_Command(msg)
-- отключение
if msg == "off" then
DEFAULT_CHAT_FRAME:AddMessage(format("Secret Function |cffff0000OFF|r. Thanks for using this addon. Wishko"))
SetCVar("cameraDistanceMax",25) -- устанавливается максимальная дистанция 
MoveViewLeftStop()    -- движение камеры влево по окружности останавливается
MoveViewOutStop()     -- движение камеры от персонажа останавливается
SetView(4)            -- устанавливается позиция камеры №4
else
-- включение
DEFAULT_CHAT_FRAME:AddMessage(format("It's not known how, but you have turn |cff00ff00ON|r a Secret Function. =)".. 
" To turn off it, write '|cff00ff00/camdist off|r'."))
SetView(1)                      -- устанавливается вид от первого лица
SetCVar("cameraDistanceMax",50) -- устанавливается максимальная дистанция (50м.)
MoveViewLeftStart(0.1)          -- камера движется влево по окружности
MoveViewOutStart(0.1)           -- камера отдаляется от персонажа
end
end 

-- P.S.: Заки - самый большой склерозник, хоть и помог мне немного с этим аддОном и локализацией к нему (особенно с yard-yards)